Subject: Re: [bug#42123] [PATCH] linux-libre: Enable module compression.

From: Ludovic Courtès <[email-masked]>
Date: Sun, 23 Aug 2020 18:27:45 +0200

Hello!

Apologies for the holiday-induced delay!

Mathieu Othacehe <[email-masked]> skribis:

>> This can be decomposed in several steps:
>>
>>   1. We can start using ‘guile-zlib’ as extensions for gexps: in (guix
>>      scripts pack), (guix download), etc.  Easy, no risk.
>
> There's an attached patch that should cover this first step. An issue
> here is that (guix build download-nar) is built in both "make" and "guix
> pull" commands, so I cannot use a bare:
>
> #:use-module (zlib)
>
>
> so, I used:
>
> #:autoload   (zlib) (call-with-gzip-input-port)
>
> that seems to work but produces a lot of warnings when running
> "make". Would it be acceptable as a first step?

Yeah, sounds good to me.

>>   2. Use guile-zlib & co. in Guix itself: (guix scripts substitute),
>>      (guix scripts publish), etc.  Keep (guix zlib) and (guix lzlib) in
>>      parallel.
>
> I'm not sure how it can work without step 4. For me, including (zlib) in
> Guix itself requires that build machinery and (guix self) are updated,
> but maybe I'm missing something.

Hmm you must be right.  Well in that case you can do these in lockstep.
Sorry for the confusion!

> From 680e19137d22204f34b00336a3cb98a02397b0f9 Mon Sep 17 00:00:00 2001
> From: Mathieu Othacehe <[email-masked]>
> Date: Thu, 6 Aug 2020 15:00:01 +0200
> Subject: [PATCH] Use guile-zlib extension in build-side code.
>
> * Makefile.am (MODULES): Move guix/build/download-nar.scm to ...
> (MODULES_NOT_COMPILED): ... here.
> * guix/build/download-nar.scm: Use (zlib) instead of (guix zlib).
> * guix/cvs-download.scm (cvs-fetch): Do not stub (guix config) in imported
> modules list, instead add "guile-zlib" to the extension list.
> * guix/git-download.scm (git-fetch): Ditto.
> * guix/hg-download.scm (hg-fetch): Do not stub (guix config) in imported
> modules list, instead add "guile-zlib" to the extension list.

LGTM!  Glad we’re making progress on this front, thanks a lot!

Ludo’.